7167: add keep-rsync to gostuff.
[arvados-dev.git] / jenkins / run-tests.sh
1 #!/bin/bash
2
3 . `dirname "$(readlink -f "$0")"`/libcloud-pin
4
5 read -rd "\000" helpmessage <<EOF
6 $(basename $0): Install and test Arvados components.
7
8 Exit non-zero if any tests fail.
9
10 Syntax:
11         $(basename $0) WORKSPACE=/path/to/arvados [options]
12
13 Options:
14
15 --skip FOO     Do not test the FOO component.
16 --only FOO     Do not test anything except the FOO component.
17 --temp DIR     Install components and dependencies under DIR instead of
18                making a new temporary directory. Implies --leave-temp.
19 --leave-temp   Do not remove GOPATH, virtualenv, and other temp dirs at exit.
20                Instead, show the path to give as --temp to reuse them in
21                subsequent invocations.
22 --skip-install Do not run any install steps. Just run tests.
23                You should provide GOPATH, GEMHOME, and VENVDIR options
24                from a previous invocation if you use this option.
25 --only-install Run specific install step
26 WORKSPACE=path Arvados source tree to test.
27 CONFIGSRC=path Dir with api server config files to copy into source tree.
28                (If none given, leave config files alone in source tree.)
29 services/api_test="TEST=test/functional/arvados/v1/collections_controller_test.rb"
30                Restrict apiserver tests to the given file
31 sdk/python_test="--test-suite test.test_keep_locator"
32                Restrict Python SDK tests to the given class
33 apps/workbench_test="TEST=test/integration/pipeline_instances_test.rb"
34                Restrict Workbench tests to the given file
35 services/arv-git-httpd_test="-check.vv"
36                Show all log messages, even when tests pass (also works
37                with services/keepstore_test etc.)
38 ARVADOS_DEBUG=1
39                Print more debug messages
40 envvar=value   Set \$envvar to value. Primarily useful for WORKSPACE,
41                *_test, and other examples shown above.
42
43 Assuming --skip-install is not given, all components are installed
44 into \$GOPATH, \$VENDIR, and \$GEMHOME before running any tests. Many
45 test suites depend on other components being installed, and installing
46 everything tends to be quicker than debugging dependencies.
47
48 As a special concession to the current CI server config, CONFIGSRC
49 defaults to $HOME/arvados-api-server if that directory exists.
50
51 More information and background:
52
53 https://arvados.org/projects/arvados/wiki/Running_tests
54
55 Available tests:
56
57 apps/workbench
58 apps/workbench_benchmark
59 apps/workbench_profile
60 doc
61 services/api
62 services/crunchstat
63 services/dockercleaner
64 services/fuse
65 services/keepproxy
66 services/keepstore
67 services/login-sync
68 services/nodemanager
69 services/arv-git-httpd
70 sdk/cli
71 sdk/pam
72 sdk/python
73 sdk/ruby
74 sdk/go/arvadosclient
75 sdk/go/keepclient
76 sdk/go/streamer
77 tools/keep-rsync
78
79 EOF
80
81 # First make sure to remove any ARVADOS_ variables from the calling
82 # environment that could interfere with the tests.
83 unset $(env | cut -d= -f1 | grep \^ARVADOS_)
84
85 # Reset other variables that could affect our [tests'] behavior by
86 # accident.
87 GITDIR=
88 GOPATH=
89 VENVDIR=
90 VENV3DIR=
91 PYTHONPATH=
92 GEMHOME=
93 PERLINSTALLBASE=
94
95 COLUMNS=80
96
97 skip_install=
98 temp=
99 temp_preserve=
100
101 clear_temp() {
102     if [[ -z "$temp" ]]; then
103         # we didn't even get as far as making a temp dir
104         :
105     elif [[ -z "$temp_preserve" ]]; then
106         rm -rf "$temp"
107     else
108         echo "Leaving behind temp dirs in $temp"
109     fi
110 }
111
112 fatal() {
113     clear_temp
114     echo >&2 "Fatal: $* (encountered in ${FUNCNAME[1]} at ${BASH_SOURCE[1]} line ${BASH_LINENO[0]})"
115     exit 1
116 }
117
118 report_outcomes() {
119     for x in "${successes[@]}"
120     do
121         echo "Pass: $x"
122     done
123
124     if [[ ${#failures[@]} == 0 ]]
125     then
126         echo "All test suites passed."
127     else
128         echo "Failures (${#failures[@]}):"
129         for x in "${failures[@]}"
130         do
131             echo "Fail: $x"
132         done
133     fi
134 }
135
136 exit_cleanly() {
137     trap - INT
138     create-plot-data-from-log.sh $BUILD_NUMBER "$WORKSPACE/apps/workbench/log/test.log" "$WORKSPACE/apps/workbench/log/"
139     rotate_logfile "$WORKSPACE/apps/workbench/log/" "test.log"
140     stop_services
141     rotate_logfile "$WORKSPACE/services/api/log/" "test.log"
142     report_outcomes
143     clear_temp
144     exit ${#failures}
145 }
146
147 sanity_checks() {
148     ( [[ -n "$WORKSPACE" ]] && [[ -d "$WORKSPACE/services" ]] ) \
149         || fatal "WORKSPACE environment variable not set to a source directory (see: $0 --help)"
150     echo Checking dependencies:
151     echo -n 'virtualenv: '
152     virtualenv --version \
153         || fatal "No virtualenv. Try: apt-get install virtualenv"
154     echo -n 'go: '
155     go version \
156         || fatal "No go binary. See http://golang.org/doc/install"
157     echo -n 'gcc: '
158     gcc --version | egrep ^gcc \
159         || fatal "No gcc. Try: apt-get install build-essential"
160     echo -n 'fuse.h: '
161     find /usr/include -wholename '*fuse/fuse.h' \
162         || fatal "No fuse/fuse.h. Try: apt-get install libfuse-dev"
163     echo -n 'pyconfig.h: '
164     find /usr/include -name pyconfig.h | egrep --max-count=1 . \
165         || fatal "No pyconfig.h. Try: apt-get install python-dev"
166     echo -n 'nginx: '
167     PATH="$PATH:/sbin:/usr/sbin:/usr/local/sbin" nginx -v \
168         || fatal "No nginx. Try: apt-get install nginx"
169     echo -n 'perl: '
170     perl -v | grep version \
171         || fatal "No perl. Try: apt-get install perl"
172     for mod in ExtUtils::MakeMaker JSON LWP Net::SSL; do
173         echo -n "perl $mod: "
174         perl -e "use $mod; print \"\$$mod::VERSION\\n\"" \
175             || fatal "No $mod. Try: apt-get install perl-modules libcrypt-ssleay-perl libjson-perl"
176     done
177     echo -n 'gitolite: '
178     which gitolite \
179         || fatal "No gitolite. Try: apt-get install gitolite3"
180 }
181
182 rotate_logfile() {
183   # i.e.  rotate_logfile "$WORKSPACE/apps/workbench/log/" "test.log"
184   # $BUILD_NUMBER is set by Jenkins if this script is being called as part of a Jenkins run
185   if [[ -f "$1/$2" ]]; then
186     THEDATE=`date +%Y%m%d%H%M%S`
187     mv "$1/$2" "$1/$THEDATE-$BUILD_NUMBER-$2"
188     gzip "$1/$THEDATE-$BUILD_NUMBER-$2"
189   fi
190 }
191
192 declare -a failures
193 declare -A skip
194 declare -A testargs
195 skip[apps/workbench_profile]=1
196
197 while [[ -n "$1" ]]
198 do
199     arg="$1"; shift
200     case "$arg" in
201         --help)
202             echo >&2 "$helpmessage"
203             echo >&2
204             exit 1
205             ;;
206         --skip)
207             skipwhat="$1"; shift
208             skip[$skipwhat]=1
209             ;;
210         --only)
211             only="$1"; skip[$1]=""; shift
212             ;;
213         --skip-install)
214             skip_install=1
215             ;;
216         --only-install)
217             skip_install=1
218             only_install="$1"; shift
219             ;;
220         --temp)
221             temp="$1"; shift
222             temp_preserve=1
223             ;;
224         --leave-temp)
225             temp_preserve=1
226             ;;
227         --retry)
228             retry=1
229             ;;
230         *_test=*)
231             suite="${arg%%_test=*}"
232             args="${arg#*=}"
233             testargs["$suite"]="$args"
234             ;;
235         *=*)
236             eval export $(echo $arg | cut -d= -f1)=\"$(echo $arg | cut -d= -f2-)\"
237             ;;
238         *)
239             echo >&2 "$0: Unrecognized option: '$arg'. Try: $0 --help"
240             exit 1
241             ;;
242     esac
243 done
244
245 start_api() {
246     echo 'Starting API server...'
247     cd "$WORKSPACE" \
248         && eval $(python sdk/python/tests/run_test_server.py start --auth admin) \
249         && export ARVADOS_TEST_API_HOST="$ARVADOS_API_HOST" \
250         && export ARVADOS_TEST_API_INSTALLED="$$" \
251         && (env | egrep ^ARVADOS)
252 }
253
254 start_nginx_proxy_services() {
255     echo 'Starting keepproxy, arv-git-httpd, and nginx ssl proxy...'
256     cd "$WORKSPACE" \
257         && python sdk/python/tests/run_test_server.py start_keep_proxy \
258         && python sdk/python/tests/run_test_server.py start_arv-git-httpd \
259         && python sdk/python/tests/run_test_server.py start_nginx \
260         && export ARVADOS_TEST_PROXY_SERVICES=1
261 }
262
263 stop_services() {
264     if [[ -n "$ARVADOS_TEST_PROXY_SERVICES" ]]; then
265         unset ARVADOS_TEST_PROXY_SERVICES
266         cd "$WORKSPACE" \
267             && python sdk/python/tests/run_test_server.py stop_nginx \
268             && python sdk/python/tests/run_test_server.py stop_arv-git-httpd \
269             && python sdk/python/tests/run_test_server.py stop_keep_proxy
270     fi
271     if [[ -n "$ARVADOS_TEST_API_HOST" ]]; then
272         unset ARVADOS_TEST_API_HOST
273         cd "$WORKSPACE" \
274             && python sdk/python/tests/run_test_server.py stop
275     fi
276 }
277
278 interrupt() {
279     failures+=("($(basename $0) interrupted)")
280     exit_cleanly
281 }
282 trap interrupt INT
283
284 sanity_checks
285
286 echo "WORKSPACE=$WORKSPACE"
287
288 if [[ -z "$CONFIGSRC" ]] && [[ -d "$HOME/arvados-api-server" ]]; then
289     # Jenkins expects us to use this by default.
290     CONFIGSRC="$HOME/arvados-api-server"
291 fi
292
293 # Clean up .pyc files that may exist in the workspace
294 cd "$WORKSPACE"
295 find -name '*.pyc' -delete
296
297 if [[ -z "$temp" ]]; then
298     temp="$(mktemp -d)"
299 fi
300
301 # Set up temporary install dirs (unless existing dirs were supplied)
302 for tmpdir in VENVDIR VENV3DIR GOPATH GEMHOME PERLINSTALLBASE
303 do
304     if [[ -z "${!tmpdir}" ]]; then
305         eval "$tmpdir"="$temp/$tmpdir"
306     fi
307     if ! [[ -d "${!tmpdir}" ]]; then
308         mkdir "${!tmpdir}" || fatal "can't create ${!tmpdir} (does $temp exist?)"
309     fi
310 done
311
312 setup_ruby_environment() {
313     if [[ -s "$HOME/.rvm/scripts/rvm" ]] ; then
314       source "$HOME/.rvm/scripts/rvm"
315       using_rvm=true
316     elif [[ -s "/usr/local/rvm/scripts/rvm" ]] ; then
317       source "/usr/local/rvm/scripts/rvm"
318       using_rvm=true
319     else
320       using_rvm=false
321     fi
322
323     if [[ "$using_rvm" == true ]]; then
324         # If rvm is in use, we can't just put separate "dependencies"
325         # and "gems-under-test" paths to GEM_PATH: passenger resets
326         # the environment to the "current gemset", which would lose
327         # our GEM_PATH and prevent our test suites from running ruby
328         # programs (for example, the Workbench test suite could not
329         # boot an API server or run arv). Instead, we have to make an
330         # rvm gemset and use it for everything.
331
332         [[ `type rvm | head -n1` == "rvm is a function" ]] \
333             || fatal 'rvm check'
334
335         # Put rvm's favorite path back in first place (overriding
336         # virtualenv, which just put itself there). Ignore rvm's
337         # complaint about not being in first place already.
338         rvm use @default 2>/dev/null
339
340         # Create (if needed) and switch to an @arvados-tests
341         # gemset. (Leave the choice of ruby to the caller.)
342         rvm use @arvados-tests --create \
343             || fatal 'rvm gemset setup'
344
345         rvm env
346     else
347         # When our "bundle install"s need to install new gems to
348         # satisfy dependencies, we want them to go where "gem install
349         # --user-install" would put them. (However, if the caller has
350         # already set GEM_HOME, we assume that's where dependencies
351         # should be installed, and we should leave it alone.)
352
353         if [ -z "$GEM_HOME" ]; then
354             user_gempath="$(gem env gempath)"
355             export GEM_HOME="${user_gempath%%:*}"
356         fi
357         PATH="$(gem env gemdir)/bin:$PATH"
358
359         # When we build and install our own gems, we install them in our
360         # $GEMHOME tmpdir, and we want them to be at the front of GEM_PATH and
361         # PATH so integration tests prefer them over other versions that
362         # happen to be installed in $user_gempath, system dirs, etc.
363
364         tmpdir_gem_home="$(env - PATH="$PATH" HOME="$GEMHOME" gem env gempath | cut -f1 -d:)"
365         PATH="$tmpdir_gem_home/bin:$PATH"
366         export GEM_PATH="$tmpdir_gem_home:$(gem env gempath)"
367
368         echo "Will install dependencies to $(gem env gemdir)"
369         echo "Will install arvados gems to $tmpdir_gem_home"
370         echo "Gem search path is GEM_PATH=$GEM_PATH"
371     fi
372 }
373
374 with_test_gemset() {
375     if [[ "$using_rvm" == true ]]; then
376         "$@"
377     else
378         GEM_HOME="$tmpdir_gem_home" GEM_PATH="$tmpdir_gem_home" "$@"
379     fi
380 }
381
382 gem_uninstall_if_exists() {
383     if gem list "$1\$" | egrep '^\w'; then
384         gem uninstall --force --all --executables "$1"
385     fi
386 }
387
388 export PERLINSTALLBASE
389 export PERLLIB="$PERLINSTALLBASE/lib/perl5:${PERLLIB:+$PERLLIB}"
390
391 export GOPATH
392 mkdir -p "$GOPATH/src/git.curoverse.com"
393 ln -sfn "$WORKSPACE" "$GOPATH/src/git.curoverse.com/arvados.git" \
394     || fatal "symlink failed"
395
396 if ! [[ -e "$VENVDIR/bin/activate" ]] || ! [[ -e "$VENVDIR/bin/pip" ]]; then
397     virtualenv --setuptools "$VENVDIR" || fatal "virtualenv $VENVDIR failed"
398 fi
399 . "$VENVDIR/bin/activate"
400
401 if (pip install setuptools | grep setuptools-0) || [ "$($VENVDIR/bin/easy_install --version | cut -d\  -f2 | cut -d. -f1)" -lt 18 ]; then
402     pip install --upgrade setuptools pip
403 fi
404
405 # Needed for run_test_server.py which is used by certain (non-Python) tests.
406 pip freeze 2>/dev/null | egrep ^PyYAML= \
407     || pip install PyYAML >/dev/null \
408     || fatal "pip install PyYAML failed"
409
410 # Preinstall forked version of libcloud, because nodemanager "pip install"
411 # won't pick it up by default.
412 pip freeze 2>/dev/null | egrep ^apache-libcloud==$LIBCLOUD_PIN \
413     || pip install --pre --ignore-installed https://github.com/curoverse/libcloud/archive/apache-libcloud-$LIBCLOUD_PIN.zip >/dev/null \
414     || fatal "pip install apache-libcloud failed"
415
416 # Deactivate Python 2 virtualenv
417 deactivate
418
419 # If Python 3 is available, set up its virtualenv in $VENV3DIR.
420 # Otherwise, skip dependent tests.
421 PYTHON3=$(which python3)
422 if [ "0" = "$?" ]; then
423     virtualenv --python "$PYTHON3" --setuptools "$VENV3DIR" \
424         || fatal "python3 virtualenv $VENV3DIR failed"
425
426     . "$VENV3DIR/bin/activate"
427
428     if (pip install setuptools | grep setuptools-0) || [ "$($VENV3DIR/bin/easy_install --version | cut -d\  -f2 | cut -d. -f1)" -lt 18 ]; then
429         pip install --upgrade setuptools pip
430     fi
431
432     # Deactivate Python 3 virtualenv
433     deactivate
434 else
435     PYTHON3=
436     skip[services/dockercleaner]=1
437     cat >&2 <<EOF
438
439 Warning: python3 could not be found
440 services/dockercleaner install and tests will be skipped
441
442 EOF
443 fi
444
445 # Reactivate Python 2 virtualenv
446 . "$VENVDIR/bin/activate"
447
448 # Note: this must be the last time we change PATH, otherwise rvm will
449 # whine a lot.
450 setup_ruby_environment
451
452 echo "PATH is $PATH"
453
454 if ! which bundler >/dev/null
455 then
456     gem install --user-install bundler || fatal 'Could not install bundler'
457 fi
458
459 checkexit() {
460     if [[ "$1" != "0" ]]; then
461         title "!!!!!! $2 FAILED !!!!!!"
462         failures+=("$2 (`timer`)")
463     else
464         successes+=("$2 (`timer`)")
465     fi
466 }
467
468 timer_reset() {
469     t0=$SECONDS
470 }
471
472 timer() {
473     echo -n "$(($SECONDS - $t0))s"
474 }
475
476 do_test() {
477     while ! do_test_once ${@} && [[ "$retry" == 1 ]]
478     do
479         read -p 'Try again? [Y/n] ' x
480         if [[ "$x" != "y" ]] && [[ "$x" != "" ]]
481         then
482             break
483         fi
484     done
485 }
486
487 do_test_once() {
488     unset result
489     if [[ -z "${skip[$1]}" ]] && ( [[ -z "$only" ]] || [[ "$only" == "$1" ]] )
490     then
491         title "Running $1 tests"
492         timer_reset
493         if [[ "$2" == "go" ]]
494         then
495             covername="coverage-$(echo "$1" | sed -e 's/\//_/g')"
496             coverflags=("-covermode=count" "-coverprofile=$WORKSPACE/tmp/.$covername.tmp")
497             if [[ -n "${testargs[$1]}" ]]
498             then
499                 # "go test -check.vv giturl" doesn't work, but this
500                 # does:
501                 cd "$WORKSPACE/$1" && go test ${coverflags[@]} ${testargs[$1]}
502             else
503                 # The above form gets verbose even when testargs is
504                 # empty, so use this form in such cases:
505                 go test ${coverflags[@]} "git.curoverse.com/arvados.git/$1"
506             fi
507             result="$?"
508             go tool cover -html="$WORKSPACE/tmp/.$covername.tmp" -o "$WORKSPACE/tmp/$covername.html"
509             rm "$WORKSPACE/tmp/.$covername.tmp"
510         elif [[ "$2" == "pip" ]]
511         then
512             # $3 can name a path directory for us to use, including trailing
513             # slash; e.g., the bin/ subdirectory of a virtualenv.
514             cd "$WORKSPACE/$1" \
515                 && "${3}python" setup.py test ${testargs[$1]}
516         elif [[ "$2" != "" ]]
517         then
518             "test_$2"
519         else
520             "test_$1"
521         fi
522         result=${result:-$?}
523         checkexit $result "$1 tests"
524         title "End of $1 tests (`timer`)"
525         return $result
526     else
527         title "Skipping $1 tests"
528     fi
529 }
530
531 do_install() {
532     if [[ -z "$skip_install" || (-n "$only_install" && "$only_install" == "$1") ]]
533     then
534         title "Running $1 install"
535         timer_reset
536         if [[ "$2" == "go" ]]
537         then
538             go get -t "git.curoverse.com/arvados.git/$1"
539         elif [[ "$2" == "pip" ]]
540         then
541             # $3 can name a path directory for us to use, including trailing
542             # slash; e.g., the bin/ subdirectory of a virtualenv.
543
544             # Need to change to a different directory after creating
545             # the source dist package to avoid a pip bug.
546             # see https://arvados.org/issues/5766 for details.
547
548             # Also need to install twice, because if it believes the package is
549             # already installed, pip it won't install it.  So the first "pip
550             # install" ensures that the dependencies are met, the second "pip
551             # install" ensures that we've actually installed the local package
552             # we just built.
553             cd "$WORKSPACE/$1" \
554                 && "${3}python" setup.py sdist rotate --keep=1 --match .tar.gz \
555                 && cd "$WORKSPACE" \
556                 && "${3}pip" install --quiet "$WORKSPACE/$1/dist"/*.tar.gz \
557                 && "${3}pip" install --quiet --no-deps --ignore-installed "$WORKSPACE/$1/dist"/*.tar.gz
558         elif [[ "$2" != "" ]]
559         then
560             "install_$2"
561         else
562             "install_$1"
563         fi
564         checkexit $? "$1 install"
565         title "End of $1 install (`timer`)"
566     else
567         title "Skipping $1 install"
568     fi
569 }
570
571 title () {
572     txt="********** $1 **********"
573     printf "\n%*s%s\n\n" $((($COLUMNS-${#txt})/2)) "" "$txt"
574 }
575
576 bundle_install_trylocal() {
577     (
578         set -e
579         echo "(Running bundle install --local. 'could not find package' messages are OK.)"
580         if ! bundle install --local --no-deployment; then
581             echo "(Running bundle install again, without --local.)"
582             bundle install --no-deployment
583         fi
584         bundle package --all
585     )
586 }
587
588 install_doc() {
589     cd "$WORKSPACE/doc" \
590         && bundle_install_trylocal \
591         && rm -rf .site
592 }
593 do_install doc
594
595 install_gem() {
596     gemname=$1
597     srcpath=$2
598     with_test_gemset gem_uninstall_if_exists "$gemname" \
599         && cd "$WORKSPACE/$srcpath" \
600         && bundle_install_trylocal \
601         && gem build "$gemname.gemspec" \
602         && with_test_gemset gem install --no-ri --no-rdoc $(ls -t "$gemname"-*.gem|head -n1)
603 }
604
605 install_ruby_sdk() {
606     install_gem arvados sdk/ruby
607 }
608 do_install sdk/ruby ruby_sdk
609
610 install_perl_sdk() {
611     cd "$WORKSPACE/sdk/perl" \
612         && perl Makefile.PL INSTALL_BASE="$PERLINSTALLBASE" \
613         && make install INSTALLDIRS=perl
614 }
615 do_install sdk/perl perl_sdk
616
617 install_cli() {
618     install_gem arvados-cli sdk/cli
619 }
620 do_install sdk/cli cli
621
622 install_login-sync() {
623     install_gem arvados-login-sync services/login-sync
624 }
625 do_install services/login-sync login-sync
626
627 # Install the Python SDK early. Various other test suites (like
628 # keepproxy) bring up run_test_server.py, which imports the arvados
629 # module. We can't actually *test* the Python SDK yet though, because
630 # its own test suite brings up some of those other programs (like
631 # keepproxy).
632 declare -a pythonstuff
633 pythonstuff=(
634     sdk/pam
635     sdk/python
636     services/fuse
637     services/nodemanager
638     )
639 for p in "${pythonstuff[@]}"
640 do
641     do_install "$p" pip
642 done
643 if [ -n "$PYTHON3" ]; then
644     do_install services/dockercleaner pip "$VENV3DIR/bin/"
645 fi
646
647 install_apiserver() {
648     cd "$WORKSPACE/services/api" \
649         && RAILS_ENV=test bundle_install_trylocal
650
651     rm -f config/environments/test.rb
652     cp config/environments/test.rb.example config/environments/test.rb
653
654     if [ -n "$CONFIGSRC" ]
655     then
656         for f in database.yml application.yml
657         do
658             cp "$CONFIGSRC/$f" config/ || fatal "$f"
659         done
660     fi
661
662     # Fill in a random secret_token and blob_signing_key for testing
663     SECRET_TOKEN=`echo 'puts rand(2**512).to_s(36)' |ruby`
664     BLOB_SIGNING_KEY=`echo 'puts rand(2**512).to_s(36)' |ruby`
665
666     sed -i'' -e "s:SECRET_TOKEN:$SECRET_TOKEN:" config/application.yml
667     sed -i'' -e "s:BLOB_SIGNING_KEY:$BLOB_SIGNING_KEY:" config/application.yml
668
669     # Set up empty git repo (for git tests)
670     GITDIR=$(mktemp -d)
671     sed -i'' -e "s:/var/cache/git:$GITDIR:" config/application.default.yml
672
673     rm -rf $GITDIR
674     mkdir -p $GITDIR/test
675     cd $GITDIR/test \
676         && git init \
677         && git config user.email "jenkins@ci.curoverse.com" \
678         && git config user.name "Jenkins, CI" \
679         && touch tmp \
680         && git add tmp \
681         && git commit -m 'initial commit'
682
683     # Clear out any lingering postgresql connections to the test
684     # database, so that we can drop it. This assumes the current user
685     # is a postgresql superuser.
686     cd "$WORKSPACE/services/api" \
687         && test_database=$(python -c "import yaml; print yaml.load(file('config/database.yml'))['test']['database']") \
688         && psql "$test_database" -c "SELECT pg_terminate_backend (pg_stat_activity.procpid::int) FROM pg_stat_activity WHERE pg_stat_activity.datname = '$test_database';" 2>/dev/null
689
690     cd "$WORKSPACE/services/api" \
691         && RAILS_ENV=test bundle exec rake db:drop \
692         && RAILS_ENV=test bundle exec rake db:setup \
693         && RAILS_ENV=test bundle exec rake db:fixtures:load
694 }
695 do_install services/api apiserver
696
697 declare -a gostuff
698 gostuff=(
699     sdk/go/arvadosclient
700     sdk/go/streamer
701     services/arv-git-httpd
702     services/crunchstat
703     services/keepstore
704     sdk/go/keepclient
705     services/keepproxy
706     services/datamanager/summary
707     services/datamanager/collection
708     services/datamanager
709     tools/keep-rsync
710     )
711 for g in "${gostuff[@]}"
712 do
713     do_install "$g" go
714 done
715
716 install_workbench() {
717     cd "$WORKSPACE/apps/workbench" \
718         && mkdir -p tmp/cache \
719         && RAILS_ENV=test bundle_install_trylocal
720 }
721 do_install apps/workbench workbench
722
723 test_doclinkchecker() {
724     (
725         set -e
726         cd "$WORKSPACE/doc"
727         ARVADOS_API_HOST=qr1hi.arvadosapi.com
728         # Make sure python-epydoc is installed or the next line won't
729         # do much good!
730         PYTHONPATH=$WORKSPACE/sdk/python/ bundle exec rake linkchecker baseurl=file://$WORKSPACE/doc/.site/ arvados_workbench_host=https://workbench.$ARVADOS_API_HOST arvados_api_host=$ARVADOS_API_HOST
731     )
732 }
733 do_test doc doclinkchecker
734
735 stop_services
736
737 test_apiserver() {
738     cd "$WORKSPACE/services/api" \
739         && RAILS_ENV=test bundle exec rake test TESTOPTS=-v ${testargs[services/api]}
740 }
741 do_test services/api apiserver
742
743 # Shortcut for when we're only running apiserver tests. This saves a bit of time,
744 # because we don't need to start up the api server for subsequent tests.
745 if [ ! -z "$only" ] && [ "$only" == "services/api" ]; then
746   rotate_logfile "$WORKSPACE/services/api/log/" "test.log"
747   exit_cleanly
748 fi
749
750 start_api
751
752 test_ruby_sdk() {
753     cd "$WORKSPACE/sdk/ruby" \
754         && bundle exec rake test TESTOPTS=-v ${testargs[sdk/ruby]}
755 }
756 do_test sdk/ruby ruby_sdk
757
758 test_cli() {
759     cd "$WORKSPACE/sdk/cli" \
760         && mkdir -p /tmp/keep \
761         && KEEP_LOCAL_STORE=/tmp/keep bundle exec rake test TESTOPTS=-v ${testargs[sdk/cli]}
762 }
763 do_test sdk/cli cli
764
765 test_login-sync() {
766     cd "$WORKSPACE/services/login-sync" \
767         && bundle exec rake test TESTOPTS=-v ${testargs[services/login-sync]}
768 }
769 do_test services/login-sync login-sync
770
771 for p in "${pythonstuff[@]}"
772 do
773     do_test "$p" pip
774 done
775 do_test services/dockercleaner pip "$VENV3DIR/bin/"
776
777 for g in "${gostuff[@]}"
778 do
779     do_test "$g" go
780 done
781
782 test_workbench() {
783     start_nginx_proxy_services \
784         && cd "$WORKSPACE/apps/workbench" \
785         && RAILS_ENV=test bundle exec rake test TESTOPTS=-v ${testargs[apps/workbench]}
786 }
787 do_test apps/workbench workbench
788
789 test_workbench_benchmark() {
790     start_nginx_proxy_services \
791         && cd "$WORKSPACE/apps/workbench" \
792         && RAILS_ENV=test bundle exec rake test:benchmark ${testargs[apps/workbench_benchmark]}
793 }
794 do_test apps/workbench_benchmark workbench_benchmark
795
796 test_workbench_profile() {
797     start_nginx_proxy_services \
798         && cd "$WORKSPACE/apps/workbench" \
799         && RAILS_ENV=test bundle exec rake test:profile ${testargs[apps/workbench_profile]}
800 }
801 do_test apps/workbench_profile workbench_profile
802
803 exit_cleanly